function [x,y]=heun1(n,xo,xf,yo);
dx = (xf-xo)/n;
x = zeros(n+1,1);
for i = 1:1:n+1
   x(i) = xo + (i-1)*dx;
end
y = zeros(n+1,1);
y(1) = yo;
for i =  1:1:n
   x1 = x(i);
   y1 = y(i);
   k1 = funkeval(x1,y1);
   x2 = x(i) + dx;
   y2 = y(i) + dx*k1;
   k2 = funkeval(x2,y2);
   dydx = 1.0/2.0*(k1 + k2);
   y(i+1) = y(i) + dx*dydx;
end
close all;
iplot = 1;
if (iplot == 1)
   plot (x,y,'k-o'), xlabel( 'x' ), ylabel ( 'y' );
end
fid = fopen('heun1_out.txt','w');
fprintf(fid,'x                y \n');
fprintf(fid,'%23.15e %23.15e   \n', [x,y]');
fclose(fid);

function dydx = funkeval(x,y);
dydx = -1.0*y^2;
