function [x,y]=linode_2o_seq_1_short(n,xo,xf,yo);
dx = (xf-xo)/n;
x = zeros(n+1,1);
for i = 1:1:n+1
   x(i) = xo + (i-1)*dx;
end
y = zeros(n+1,1);
y(1) = yo;
for i =  2:1:n+1
   Aii = 1.0 - 0.50*dx*funkeval_a(x(i));
   Aij = -1.0 - 0.50*dx*funkeval_a(x(i-1));
   Bi = 0.50*dx*(funkeval_b(x(i)) + funkeval_b(x(i-1)));
   y(i) = 1.0/Aii*(Bi - Aij*y(i-1));
end
close all;
iplot = 1;
if (iplot == 1)
   plot (x,y,'k-o'), xlabel( 'x' ), ylabel ( 'y' );
end
%
%  write result to file 'linode_2o_seq_1_out.txt'
%
fid = fopen('linode_2o_seq_1_out.txt','w');
fprintf(fid,'x                y \n');
fprintf(fid,'%23.15e %23.15e   \n', [x,y]');
fclose(fid);

%  dydx = a(x)*y(x) + b(x);
function a = funkeval_a(x);
a = -x;

function b = funkeval_b(x);
b = sin(x);
