function [x,y]=linode_2o_sim_1_short(n,xo,xf,yo);
dx = (xf-xo)/n;
x = zeros(n+1,1);
for i = 1:1:n+1
   x(i) = xo + (i-1)*dx;
end
y = zeros(n+1,1);
A = zeros(n+1,n+1);
B = zeros(n+1,1);
A(1,1) = 1.0;
B(1) = yo;
for i =  2:1:n+1
   B(i) = 0.50*dx*(funkeval_b(x(i)) + funkeval_b(x(i-1)));
   A(i,i) = 1.0 - 0.50*dx*funkeval_a(x(i));
   A(i,i-1) = -1.0 - 0.50*dx*funkeval_a(x(i-1));
end
invA = inv(A);
y = invA*B;
close all;
iplot = 1;
if (iplot == 1)
   plot (x,y,'k-o'), xlabel( 'x' ), ylabel ( 'y' );
end

fid = fopen('linode_2o_sim_1_out.txt','w');
fprintf(fid,'x                y \n');
fprintf(fid,'%23.15e %23.15e   \n', [x,y]');
fclose(fid);

%  dydx = a(x)*y(x) + b(x);

function a = funkeval_a(x);
a = -x;

function b = funkeval_b(x);
b = sin(x);
